<?php

    namespace Modules\Lpj\Http\Controllers;

    use App\Http\Controllers\Controller;
    use Exception;
    use Illuminate\Http\Request;
    use Maatwebsite\Excel\Facades\Excel;
    use Modules\Lpj\Exports\StatusPermohonanExport;
    use Modules\Lpj\Http\Requests\StatusPermohonanRequest;
    use Modules\Lpj\Models\StatusPermohonan;

    class StatusPermohonanController extends Controller
    {
        public $user;

        public function index()
        {
            return view('lpj::status_permohonan.index');
        }

        public function store(StatusPermohonanRequest $request)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Save to database
                    StatusPermohonan::create($validate);
                    return redirect()
                        ->route('basicdata.status-permohonan.index')
                        ->with('success', 'Status Permohonan created successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.status-permohonan.create')
                        ->with('error', 'Failed to create status permohonan');
                }
            }
        }

        public function create()
        {
            return view('lpj::status_permohonan.form');
        }

        public function edit($id)
        {
            $statusPermohonan = StatusPermohonan::find($id);
            return view('lpj::status_permohonan.form', compact('statusPermohonan'));
        }

        public function update(StatusPermohonanRequest $request, $id)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Update in database
                    $statusPermohonan = StatusPermohonan::find($id);
                    $statusPermohonan->update($validate);
                    return redirect()
                        ->route('basicdata.status-permohonan.index')
                        ->with('success', 'Status Permohonan updated successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.status-permohonan.edit', $id)
                        ->with('error', 'Failed to update status permohonan');
                }
            }
        }

        public function destroy($id)
        {
            try {
                // Delete from database
                $statusPermohonan = StatusPermohonan::find($id);
                $statusPermohonan->delete();

                echo json_encode(['success' => true, 'message' => 'Status Permohonan deleted successfully']);
            } catch (Exception $e) {
                echo json_encode(['success' => false, 'message' => 'Failed to delete status permohonan']);
            }
        }

        public function dataForDatatables(Request $request)
        {
            if (is_null($this->user) || !$this->user->can('status_permohonan.view')) {
                //abort(403, 'Sorry! You are not allowed to view users.');
            }

            // Retrieve data from the database
            $query = StatusPermohonan::query();

            // Apply search filter if provided
            if ($request->has('search') && !empty($request->get('search'))) {
                $search = $request->get('search');
                $query->where(function ($q) use ($search) {
                    $q->where('name', 'LIKE', "%$search%");
                    $q->orWhere('description', 'LIKE', "%$search%");
                });
            }

            // Apply sorting if provided
            if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
                $order  = $request->get('sortOrder');
                $column = $request->get('sortField');
                $query->orderBy($column, $order);
            }

            // Get the total count of records
            $totalRecords = $query->count();

            // Apply pagination if provided
            if ($request->has('page') && $request->has('size')) {
                $page   = $request->get('page');
                $size   = $request->get('size');
                $offset = ($page - 1) * $size; // Calculate the offset

                $query->skip($offset)->take($size);
            }

            // Get the filtered count of records
            $filteredRecords = $query->count();

            // Get the data for the current page
            $data = $query->get();

            // Calculate the page count
            $pageCount = ceil($totalRecords / $request->get('size'));

            // Calculate the current page number
            $currentPage = 0 + 1;

            // Return the response data as a JSON object
            return response()->json([
                'draw'            => $request->get('draw'),
                'recordsTotal'    => $totalRecords,
                'recordsFiltered' => $filteredRecords,
                'pageCount'       => $pageCount,
                'page'            => $currentPage,
                'totalCount'      => $totalRecords,
                'data'            => $data,
            ]);
        }

        public function export()
        {
            return Excel::download(new StatusPermohonanExport, 'status_permohonan.xlsx');
        }
    }
